/******************************************************************************/
/*! @file arraylist.h
    @brief Header file of json-c.
    @author Masashi Astro Tachibana, Apolloron Project.
 ******************************************************************************/

/*
 * $Id: arraylist.h,v 1.4 2006/01/26 02:16:28 mclark Exp $
 *
 * Copyright (c) 2004, 2005 Metaparadigm Pte. Ltd.
 * Michael Clark <michael@metaparadigm.com>
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the MIT license. See COPYING for details.
 *
 */

#ifndef _arraylist_h_
#define _arraylist_h_

namespace apolloron {

typedef void (array_list_free_fn) (void *data);

struct array_list
{
    void **array;
    int length;
    int size;
    array_list_free_fn *free_fn;
};

struct array_list* array_list_new(array_list_free_fn *free_fn);

void array_list_free(struct array_list *al);

void* array_list_get_idx(struct array_list *al, int i);

int array_list_put_idx(struct array_list *al, int i, void *data);

int array_list_add(struct array_list *al, void *data);

int array_list_length(struct array_list *al);

} // namespace apolloron

#endif
